/*
 * genital.h: General program-wide header file
 */

#define VERSION         "0.1"

#define WORDSWAP(data)                                                  \
{                                                                       \
        data = ((data << 8) & 0xff00) | ((data >> 8) & 0xff);           \
}

static inline unsigned GetWord(unsigned char *addr) 
{
        return (addr[1] << 8) | addr[0];
}

static inline void PutWord(unsigned char *addr, unsigned data)
{
        addr[1] = data >> 8;
        addr[0] = data;
}

struct genesis_struct 
{
        unsigned char                   *rom;
        unsigned char                   *ram;

        unsigned int                    version;

        int                             vsync;
        int                             pri;
};
extern volatile struct genesis_struct   genesis;

struct control_struct
{
        unsigned                        quit;
        unsigned                        ctrl1;
        unsigned                        ctrl1_select;
};
extern struct control_struct            control;

unsigned short                          MemReadWord(unsigned);
unsigned                                IOReadByte(unsigned);
void                                    IOWriteByte(unsigned, unsigned);
unsigned                                IOReadWord(unsigned);
void                                    IOWriteWord(unsigned, unsigned);
void                                    Reset();
void                                    SwapBuffer(unsigned char *, int);

